<div class="animated fadeIn">
    <div class="card" style="padding: 0.2rem">
        <div class="card-header bg-gray-200 text-primary d-flex justify-content-between">
            <div>
                <i class="fa fa-angle-double-up text-primary"></i> {{TITLE}}
            </div>
            <button style="margin-left: 1rem" class="btn btn-sm rounded btn-outline-primary" (click)="goConsult()">
                <i class="fa fa-upload"></i> Ver listado de cargas
            </button>
        </div>
        <div class="card-body mt-4 p-0">

            <div class="row justify-content-center align-items-center text-primary">

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Listas:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <select [(ngModel)]="valueList" (change)="onChange()" class="form-control">
                                    <option *ngFor="let list of listaListFiltered"
                                            value="{{ list.id }}">{{ list.nombre }}</option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-6 col-lg-3">
                    <button class="btn bg-primary rounded" (click)="selectedList(message)">
                        <i class="fa fa-arrow-right"></i> Seleccionar
                    </button>
                </div>

            </div>
            <br>

            <div class="row justify-content-center align-items-center text-primary">

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Solicitado por:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="solicitadoPor" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Cargado por:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="cargadoPor" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Fecha de carga:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-calendar text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="fechaCreacion" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-6 col-lg-3">
                    <div class="form-group">
                        <label class="col-form-label">Cantidad de registros:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-calendar text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="cantRegs" type="text" class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-8">
                    <button [disabled]="!selectStatus" class="btn bg-primary rounded" (click)="exportExcel()">
                        <i class="fa fa-upload"></i> Descargar plantilla de campos de lista
                    </button>
                    <button [disabled]="!selectStatus" class="btn bg-primary rounded" (click)="upFileList(upFile)">
                        <i class="fa fa-upload"></i> Cargar nuevo archivo
                    </button>
                </div>
            </div>

            <br>
            <div *ngIf="this.headFields.length > 0">
                <div class="column">
                    <label class="control">Registros a mostrar:
                        <input style="width: 15%" type="number" class="input" min="1" [(ngModel)]="configPage.itemsPerPage">
                    </label>
                </div>
                <table *ngIf="this.headFields.length > 0" class="table table-sm table-hover">
                    <thead class="bg-primary">
                    <tr>
                        <th *ngFor="let head of this.headFields" scope="col">{{ head.label }}</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr *ngFor="let fields of this.listRegUpload | paginate: configPage">
                        <td *ngFor="let field of this.ordenLista(fields)">{{ field.valor }}</td>
                    </tr>
                    </tbody>
                </table>
                <pagination-controls *ngIf="this.headFields.length > 0"
                                     (pageChange)="onPageChange($event)"
                                     [id]="configPage.id"
                                     [previousLabel]="'Anterior'"
                                     [nextLabel]="'Siguiente'"

                ></pagination-controls>
            </div>
            <br>

        </div>
    </div>
</div>

<ng-template #upFile>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Carga de archivo</h5>
        </div>

        <div class="modal-body">


            <div class="form-group">
                <label class="col-form-label">Área Solicitante:</label>
                <div class="controls">
                    <div class="input-prepend input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text"><i class="fa fa-th-large text-primary"></i></span>
                        </div>
                        <select [(ngModel)]="valueArea" class="form-control">
                            <option *ngFor="let area of listAreas" value="{{area.id}}">{{ area.nombre }}</option>
                        </select>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label class="col-form-label">Seleccionar archivo:</label>
                <div class="controls">
                    <div class="input-prepend input-group">
                        <div class="input-group-prepend">
                            <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                        </div>
                        <input type="file" class="form-control" style="display: inline-block;"
                               (change)="onFileChange($event)" multiple="false" placeholder="Seleccionar Archivo"
                               accept=".xls,.xlsx">
                    </div>
                </div>
            </div>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="validate(previewdata, errorsList)"><i
                    class="fa fa-plus" aria-hidden="true"></i>
                Subir
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                <i class="fa fa-close" aria-hidden="true"></i> Cerrar
            </button>
        </div>
    </div>
</ng-template>

<ng-template #previewdata>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Previsualizacion de datos</h5>
        </div>

        <div class="modal-body">
            <p class="text-center" style="color: red">**La primera linea del archivo son los titulos de las columnas asi
                como esta en la plantilla**</p>
            <p class="text-center" style="color: red">**Se visualizan solo las primeras 10 lineas del archivo**</p>
            <div class="row justify-content-center align-items-center text-primary">

                <div class="col-12 col-md-4">
                    <div class="form-group">
                        <label class="col-form-label">Solicitado por:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="this.selectArea.name" type="text"
                                       class="form-control">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-4">
                    <div class="form-group">
                        <label class="col-form-label">Cargado por:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="this.profile.usuario.usuario" type="text"
                                       class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 col-md-4">
                    <div class="form-group">
                        <label class="col-form-label">No de Registros:</label>
                        <div class="controls">
                            <div class="input-prepend input-group">
                                <div class="input-group-prepend">
                                    <span class="input-group-text"><i class="fa fa-bars text-primary"></i></span>
                                </div>
                                <input [disabled]="true" [(ngModel)]="this.data.length" type="text"
                                       class="form-control">
                            </div>
                        </div>
                    </div>
                </div>
            </div>


            <table *ngIf=" listaPP !== undefined" class="table table-sm table-hover">
                <thead class="bg-primary">
                <tr>
                    <th *ngFor="let head of headFieldsExport" scope="col">{{ head.campo.label }}</th>
                </tr>
                </thead>
                <tbody>
                <tr *ngFor="let fields of this.newData">
                    <td *ngFor="let field of fields">{{ field }}</td>
                </tr>
                </tbody>
            </table>
        </div>

        <div class="modal-footer">
            <button type="button" [disabled]="!validFile" class="btn btn-sm btn-primary rounded"
                    (click)="verifyFile(confirm)"><i class="fa fa-plus" aria-hidden="true"></i>
                Importar Datos
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                <i class="fa fa-close" aria-hidden="true"></i> Cerrar
            </button>
        </div>
    </div>
</ng-template>

<ng-template #confirm>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Confirmar</h5>
        </div>

        <div class="modal-body">
            <h4 class="text-center">Esta seguro de importar el archivo seleccionado?</h4>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="importData()">
                <i class="fa fa-plus" aria-hidden="true"></i>
                Aceptar
            </button>
            <button type="button" class="btn btn-sm btn-danger rounded" data-dismiss="modal" (click)="closeModal()">
                <i class="fa fa-close" aria-hidden="true"></i> Cancelar
            </button>
        </div>
    </div>
</ng-template>


<ng-template #message>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Indicaciones para importar registros a una lista</h5>
        </div>

        <div class="modal-body">
            <h6>- Descargue el archivo plantilla para ver el orden de los campos en la lista seleccionada (Debe respetar el orden de los campos)</h6>
            <h6>- El archivo debe incluir los títulos de los campos en la primera fila como se muestra en la platilla</h6>
            <h6>- Verificar que en el archivo de excel todas las columnas estén en formato texto</h6>
            <h6>- El formato para campos de Fecha es YYYY-MM-DD</h6>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="cerrarMensaje()">
                <i class="fa fa-plus" aria-hidden="true"></i>
                Aceptar
            </button>
        </div>
    </div>
</ng-template>

<ng-template #errorsList>
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">Listado de errores encontrados</h5>
        </div>

        <div class="modal-body">
            <h4>Detalle:</h4>
            <br>
            <table *ngIf=" this.errors.length > 0" class="table table-sm table-hover">
                <thead class="bg-primary">
                <tr>
                    <th scope="col">Fila</th>
                    <th scope="col">Columna</th>
                    <th scope="col">Campo</th>
                    <th scope="col">Tipo de campo</th>
                    <th scope="col">Valor ingreado</th>
                    <th scope="col">Descripción</th>
                </tr>
                </thead>
                <tbody>
                <tr *ngFor="let field of this.errors">
                    <td>{{ field.fila }}</td>
                    <td>{{ field.columna }}</td>
                    <td>{{ field.campo }}</td>
                    <td *ngIf="field.tipoCampo === 'text'">Texto</td>
                    <td *ngIf="field.tipoCampo === 'num'">Numerico</td>
                    <td *ngIf="field.tipoCampo === 'date'">Fecha (YYYY-MM-DD)</td>
                    <td *ngIf="field.tipoCampo === 'scat'">Subcategoria</td>
                    <td>{{ field.valor }}</td>
                    <td>{{ field.desc }}</td>
                </tr>
                </tbody>
            </table>
        </div>

        <div class="modal-footer">
            <button type="button" class="btn btn-sm btn-primary rounded" (click)="cerrarMensaje()">
                <i class="fa fa-plus" aria-hidden="true"></i>
                Aceptar
            </button>
        </div>
    </div>
</ng-template>


